Your Name il y a 4 ans
commit
3d17febc76
3 fichiers modifiés avec 215 ajouts et 0 suppressions
  1. 0 0
      Readme.md
  2. 107 0
      build.sh
  3. 108 0
      usb.sh

+ 0 - 0
Readme.md


+ 107 - 0
build.sh

@@ -0,0 +1,107 @@
+#!/bin/bash
+Version=1.0
+Release=01/Jan/2021
+author=wareck@gmail.com
+
+Boost_v=1_67_0
+DB_v=4.8.30.NC # can be 4.8.30.NC or 4.8.30
+Miniupnpc_v=2.1
+
+echo -e "\n\e[95mSystem Check:\e[0m"
+update_me=0
+ntp_i=""
+pv_i=""
+gcc_i=""
+xz_i=""
+pixz_i=""
+pwgen_i=""
+xz_i=""
+zram_i=""
+swap_i=""
+echo -e -n "Check PV installed        : "
+if ! [ -x "$(command -v pv)" ];then echo -e "[\e[91m NO \e[0m]" && pv_i="pv" && update_me=1;else echo -e "[\e[92m OK \e[0m]";fi
+echo -e -n "Check NTP installed       : "
+if ! [ -x "$(command -v ntpd)" ];then echo -e "[\e[91m NO \e[0m]" && ntp_i="ntp" && update_me=1;else echo -e "[\e[92m OK \e[0m]";fi
+echo -e -n "Check PIXZ installed      : "
+if ! [ -x "$(command -v pixz)" ];then echo -e "[\e[91m NO \e[0m]" && pixz_i="pixz libbz2-dev liblzma-dev libzip-dev zlib1g-dev" && update_me=1;else echo -e "[\e[92m OK \e[0m]";fi
+echo -e -n "Check PWGEN installed     : "
+if ! [ -x "$(command -v pwgen)" ];then echo -e "[\e[91m NO \e[0m]" && pwgen_i="pwgen" && update_me=1;else echo -e "[\e[92m OK \e[0m]";fi
+if ! [ -x "$(command -v htop)" ];then htop_i="htop" && update_me=1;fi
+if [ $update_me = 1 ]
+then
+echo -e "\n\e[95mRaspberry update:\e[0m"
+sudo apt-get update
+sudo apt-get install aptitude -y
+sudo apt install pv python-dev build-essential $htop_i $ntp_i $pwgen_i $pixz_i $zram_i $swap_i -y
+sudo apt install libevent-dev libssl-dev autogen autoconf libtool pkg-config -y
+sudo sed -i -e "s/# set const/set const/g" /etc/nanorc
+fi
+
+echo -e "\n\e[95mDownload/Expand Boost Library:\e[0m"
+if ! [ -d $MyDir/boost_$Boost_v ]
+then
+        wget -c -q --show-progress http://wareck.free.fr/crypto/okcash/boost_$Boost_v.tar.xz
+        tar xfJ boost_$Boost_v.tar.xz --checkpoint=.500
+fi
+echo -e "Done."
+
+echo -e "\n\e[95mDonwload/Expand Miniupnpc Library:\e[0m"
+if ! [ -d $MyDir/miniupnpc-$Miniupnpc_v ]
+then
+        wget -c -q --show-progress http://wareck.free.fr/crypto/okcash/miniupnpc-$Miniupnpc_v.tar.xz
+        tar xfJ miniupnpc-$Miniupnpc_v.tar.xz --checkpoint=.1
+fi
+echo -e "Done."
+
+echo -e "\n\e[95mDownload/Expand db-4.8.30.NC Library:\e[0m"
+if ! [ -d $MyDir/db-$DB_v ]
+then
+        wget -c -q --show-progress http://wareck.free.fr/crypto/okcash/db-$DB_v.tar.xz
+        tar xfJ db-$DB_v.tar.xz --checkpoint=.100
+fi
+echo -e "Done."
+
+echo -e "\n\e[95mDownload OkCash $OKcash_v Source Code:\e[0m"
+git clone https://github.com/Bitcoin-ABC/secp256k1.git
+git clone https://github.com/litecoincash-project/litecoincash.git
+
+echo -e "Done."
+
+echo -e "\n\e[95mBuild DB-$DB_v:\e[0m"
+if [ -f /usr/share/man/man3/miniupnpc.3.gz ]; then sudo rm /usr/share/man/man3/miniupnpc.3.gz; fi
+cd db-$DB_v
+cd build_unix
+../dist/configure --enable-cxx
+make -j$(nproc)
+sudo make install
+sudo ln -s /usr/local/BerkeleyDB.4.8/lib/libdb_cxx-4.8.so /usr/lib/ || true
+cd .. && cd ..
+
+
+echo -e "\n\e[95mBuild Boost $Boost_v:\e[0m"
+cd boost_$Boost_v
+./bootstrap.sh
+sudo ./b2 --with-chrono --with-filesystem --with-program_options --with-system --with-thread --with-timer --with-test toolset=gcc variant=release link=static threading=multi runtime-link=static install
+cd ..
+
+echo -e "\n\e[95mBuild miniupnpc $Miniupnpc_v:\e[0m"
+cd miniupnpc-$Miniupnpc_v
+make -j$(nproc)
+sudo make install
+cd ..
+
+export CPATH="/usr/local/BerkeleyDB.4.8/include"
+export LIBRARY_PATH="/usr/local/BerkeleyDB.4.8/lib"
+
+cd secp256k1
+./autogen.sh
+./configure
+make
+sudo make install
+cd ..
+
+cd litecoincash
+./autogen.sh
+./configure
+make
+sudo make install

+ 108 - 0
usb.sh

@@ -0,0 +1,108 @@
+#!/bin/bash
+Version=`cat build_node.sh | grep -Po "(?<=Version=)([0-9]|\.)*(?=\s|$)"`
+echo -e "\e[93mLitecoincash Headless Node builder $Version USB Tool\e[0m"
+echo -e "Author : wareck@gmail.com"
+
+f2fs_="NO"  # add YES for f2fs, NO for ext4
+
+sda=""
+sdb=""
+sdc=""
+sdd=""
+sda=`ls -n /dev/disk/by-uuid/ | grep "sda" | awk '{print$9}'` >/dev/null
+sdb=`ls -n /dev/disk/by-uuid/ | grep "sdb" | awk '{print$9}'` >/dev/null
+sdc=`ls -n /dev/disk/by-uuid/ | grep "sdc" | awk '{print$9}'` >/dev/null
+sdd=`ls -n /dev/disk/by-uuid/ | grep "sdd" | awk '{print$9}'` >/dev/null
+
+function error_config {
+echo -e "\nChoose your file filesystem first:"
+echo "nano usb.sh"
+echo "edit f2fs=\"YES\" for f2fs or f2fs=\"NO\" for ext4"
+echo "save and run again ./usb.sh"
+echo ""
+exit
+}
+
+if [ -z $f2fs_ ]; then error_config && exit ;fi
+if ! [[ $f2fs_ = "YES"  ||  $f2fs_ = "NO" ]]
+then
+echo $f2fs_
+error_config
+fi
+
+
+if  [ -z $sda ];then sda_p=0; else sda_p=1;fi
+if  [ -z $sdb ];then sdb_p=0; else sdb_p=1;fi
+if  [ -z $sdc ];then sdc_p=0; else sdc_p=1;fi
+if  [ -z $sdd ];then sdd_p=0; else sdd_p=1;fi
+num=$(($sda_p + $sdb_p + $sdc_p + $sdd_p))
+echo ""
+if ! [ $num = 1 ]
+then
+echo -e "More than one USB drive."
+echo -e "\e[33mCan't continue automaticaly\e[0m."
+echo -e "Please remove one USB drive or do it manualy..."
+echo -e
+exit
+else
+echo -e "Drive detected => \e[32mUUID=$sda\e[0m"
+fi
+
+if ! grep -q $sda /etc/fstab
+then
+if [ -f /tmp/tmp ]; then rm /tmp/tmp ;fi
+if [ $f2fs_ = "YES" ]
+then
+sudo apt-get install f2fs-tools -y
+cat <<'EOF'>> /tmp/tmp
+#USB Drive for OkCash
+UUID=SDA  /home/pi/.litecoincash  f2fs    defaults,noatime  0       1
+EOF
+else
+cat <<'EOF'>> /tmp/tmp
+#USB Drive for OkCash
+UUID=SDA  /home/pi/.litecoincash  ext4    defaults,noatime  0       1
+EOF
+fi
+sed -i "s/SDA/$sda/" /tmp/tmp
+sed -i "s/pi/$USER/" /tmp/tmp
+sudo bash -c "cat /tmp/tmp >> /etc/fstab"
+echo -e "\n\e[95mLines added to /etc/fstab:\e[0m"
+tail -n +2 /tmp/tmp
+echo -e ""
+sleep 2
+else
+echo -e ""
+echo -e "Drive is already defined in /etc/fstab."
+echo -e ""
+sleep 1
+fi
+
+if [ ! -d /home/$USER/.litecoincash ]
+then
+echo -e "\e[95mCreate directory:\e[0m"
+echo -e "mkdir /home/$USER/.litecoincash"
+mkdir /home/$USER/.litecoincash
+sudo chown -R $USER /home/$USER/.litecoincash
+sudo chmod -R 777 /home/$USER/.litecoincash
+echo -e "Done."
+echo -e
+fi
+
+echo -e "\e[95mMount drive:\e[0m"
+sudo chown -R $USER /home/$USER/.litecoincash
+sudo chmod -R 777 /home/$USER/.litecoincash
+if mountpoint -q "/home/$USER/.litecoincash"
+then
+echo -e "Already mounted."
+echo -e "Done."
+echo -e
+else
+sudo mount /home/$USER/.litecoincash
+echo "Done."
+echo -e
+fi
+
+echo -e "\e[95mDirectory Check:\e[0m"
+ls -w 2 /home/$USER/.litecoincash
+echo -e